Subject: Re: bug#68183: 28.3; vc-dir fails when I have a certain branch checked out

From: Eli Zaretskii <[email-masked]>
Date: Tue, 20 Aug 2024 15:15:49 +0300

> From: Kévin Le Gouguec <[email-masked]>
> Cc: [email-masked],  Eli Zaretskii <[email-masked]>,  Tom Tromey
>  <[email-masked]>,  Juri Linkov <[email-masked]>,  Sean Whitton
>  <[email-masked]>
> Date: Tue, 20 Aug 2024 08:15:37 +0200
> 
> Dmitry Gutov <[email-masked]> writes:
> 
> > Hi Kevin,
> >
> > On 07/08/2024 17:25, Kévin Le Gouguec wrote:
> >> Heya,
> >> Have spent cycles on this on-and-off these past few months; finally have
> >> something worth discussing, I think 🤞
> >> To recap where we stand, AFAIU: the reported vc-dir bug has been fixed
> >> (in time for the emacs-30 branch), but the changes could feel intrusive,
> >> since a new vc-dir header was added ("Tracking") that some users may not
> >> care for.
> >
> > I haven't looked at the patch in detail, but FWIW the new header feels like a minor enough detail to not be annoying (or even noticeable) when you don't want it, but it's good to have when you do need that info.
> >
> > This is my impression after having that feature around for a few months since it's been introduced anyway.
> >
> > Just a data point. Not to imply that the code couldn't be improved, or that the new option can't be useful.
> 
> Thanks for weighing in.  Since I am not a frequent vc-dir user, my
> disposition would then be to avoid committing to sophisticated user
> options until there is demand for it.
> 
> So, at this stage, ISTM:
> 
> * We could apply [patch 1] (new tests) on emacs-30.
> 
> * I should draft a NEWS entry for the new header, for emacs-30.
> 
> * We could apply [patch 2] (refactoring; modulo the considerations
>   re. vc-git--cmds-in-progress discussed with Sean) on master, if we
>   feel like it makes vc-git-dir-extra-headers easier to work with.
> 
> 
> [patch 1]: https://debbugs.gnu.org/cgi/bugreport.cgi?bug=68183;filename=0001-Test-more-vc-dir-scenarios-with-Git-bug-68183.patch;msg=41;att=1
> 
> [patch 2]: https://debbugs.gnu.org/cgi/bugreport.cgi?bug=68183;filename=0002-Split-vc-git-dir-extra-headers-into-more-manageable-.patch;msg=41;att=2

A NEWS entry is probably OK, though I'd like to see it first.

As for adding tests, I think they should go to master.  There's no
purpose in adding them to the release branch, which is basically
frozen to code changes except bugfixes.  Since we merge code to master
routinely, any regression that happens on the branch will soon enough
land on master and will be detected there.

Thanks.